/***************************************************************************
 *            au88x0_a3d.h
 *
 *  Fri Jul 18 14:16:03 2003
 *  Copyright  2003  mjander
 *  mjander@users.sourceforge.net
 ****************************************************************************/

typedef struct {
	ulong this00; // CAsp4hwIO
	ulong this04; 
	ulong this08; // A3D slice index
	
} CA3dSourceHw_t;


short A3dHrirZeros[0x1c] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
short A3dItdDlineZeros[0x16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
short A3dHrirImpulse[0x1c] = {7FFFh,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};


/* First Register bank */
#define A3D_A_HrtfCurrent	0x18000 /* 56 ULONG */
#define A3D_A_GainCurrent	0x180E0
#define A3D_A_GainTarget	0x180E4
#define A3D_A_A12Current	0x180E8	/* Atmospheric current. */
#define A3D_A_A21Target		0x180EC /* Atmospheric target */
#define A3D_A_B01Current	0x180F0 /* Atmospheric current */
#define A3D_A_B10Target		0x180F4 /* Atmospheric target */
#define A3D_A_B2Current		0x180F8 /* Atmospheric current */
#define A3D_A_B2Target		0x180FC /* Atmospheric target */
#define A3D_A_HrtfTarget	0x18100 /* 56 ULONG */
#define A3D_A_ITDCurrent	0x181E0
#define A3D_A_ITDTarget		0x181E4
#define A3D_A_HrtfDelayLine	0x181E8	/* 56 ULONG */
#define A3D_A_ITDDelayLine	0x182C8 /* 45 ULONG */
#define A3D_A_HrtfTrackTC	0x1837C /* Time Constants */
#define A3D_A_GainTrackTC	0x18380
#define A3D_A_CoeffTrackTC	0x18384
#define A3D_A_ITDTrackTC	0x18388
#define A3D_A_x1			0x1838C
#define A3D_A_x2			0x18390
#define A3D_A_y1			0x18394
#define A3D_A_y2			0x18398
#define A3D_A_HrtfOutL		0x1839C
#define A3D_A_HrtfOutR		0x183A0
#define 	A3D_A_TAIL		0x183A4

/* Second register bank */
#define A3D_B_HrtfCurrent	0x19000	/* 56 ULONG */
#define A3D_B_GainCurrent	0x190E0
#define A3D_B_GainTarget	0x190E4
#define A3D_B_A12Current	0x190E8
#define A3D_B_A21Target		0x190EC
#define A3D_B_B01Current	0x190F0
#define A3D_B_B10Target		0x190F4
#define A3D_B_B2Current		0x190F8
#define A3D_B_B2Target		0x190FC
#define A3D_B_HrtfTarget	0x19100	/* 56 ULONG */
#define A3D_B_ITDCurrent	0x191E0
#define A3D_B_ITDTarget		0x191E4
#define A3D_B_HrtfDelayLine	0x191E8 /* 56 ULONG */
#define 	A3D_B_TAIL		0x192C8

/* There are 4 slices, 4 a3d each = 16 a3d sources.*/
#define A3D_SLICE_BANK_A		0x18000 /* 4 sources */
#define A3D_SLICE_BANK_B		0x19000 /* 4 sources */
#define A3D_SLICE_VDBDest		0x19C00 /* 8 ULONG */
#define A3D_SLICE_VDBSource		0x19C20 /* 4 ULONG */
#define A3D_SLICE_ABReg			0x19C30
#define A3D_SLICE_CReg			0x19C34
#define A3D_SLICE_Control		0x19C38
#define A3D_SLICE_DebugReserved	0x19C3c /* Dangerous! */
#define A3D_SLICE_Pointers		0x19C40 /* 4 ULONG */
#define 	A3D_SLICE_TAIL		0x1A000


/* Address generator macros. */
#define a3d_addr(slice,source,reg) ((slice<<0xf)+(source<<0xd)+reg)
/* Translate a3d index to slice,source */
#define a3d_ss(a3d) ((a3d>>2)&0x3),(a3d&0x3)
//#define a3d_write(vortex,a3d,reg,data) 

/* Left over from disassembly... */
//#define addr(a,b,c) (a + (c << 0xd) + (b*(1 + (8*4 - 3)*8))*4)
//#define addr2(a,b,c, i) (a + (((this08<<0xb)+i)<<2) + (this04*(5*9*2 - 1)*4*2))
